// This basic code was written for the IR Tank Robotic Arm project, which can be found on www.3DProjectsForTomorrow.com © 2019 3D-PFT LLC
// This code was made to work with a Unversal Remote >> Satellite >> Arris >> code >> 50869

#include <Servo.h>
#include <IRremote.h>

Servo leftservo; 
Servo rightservo;
Servo griper;
Servo griperarm1;
Servo griperarm2;
Servo griperrotate; 

int leftCenter = 90;
int rightCenter = 90;
int gripercenter = 10;
int griperarm1center = 50;
int griperarm2center = 50;
int griperrotatecenter = 90;


int IRpin = 11;

IRrecv irINput(IRpin);
decode_results results;
IRsend sender;


void setup() {
  
  leftservo.attach(9);  
  rightservo.attach(7); 
  griper.attach(5); 
  griperarm1.attach(3); 
  griperarm2.attach(4); 
  griperrotate.attach(6); 
  
  
 pinMode( 10, OUTPUT);
 pinMode( 6, OUTPUT);
 pinMode( 4, OUTPUT);
 pinMode( 3, OUTPUT);
 pinMode(5, OUTPUT);
 
 digitalWrite(10 ,HIGH); // Turn on the LED

  

  Serial.begin(9600);
  irINput.enableIRIn();
  
  
  rightservo.write(rightCenter);  
  leftservo.write(leftCenter);
  griper.write(gripercenter); 
  griperarm1.write(griperarm1center); 
  griperarm2.write(griperarm2center); 
  griperrotate.write(griperrotatecenter); 
  
  delay(1500);
  griper.detach() ; 
  griperarm1.detach(); 
  griperarm2.detach(); 
  griperrotate.detach(); 

  
  
}

int tankspeed = 45;


void loop() {
  
  

if (irINput.decode(&results)){

  long Code = results.value;
  
  
  Serial.println(results.value);
  
  switch(results.value){
    
    case 3104119154: //Go Forwards, Up Button.
    forward(tankspeed);
    break;
   
    case 4158309037 : // Go Backwards, Down Button.
    backward(tankspeed);
    break;
    
    case 1510959947: // Turn Right , Right Button.
    rightTurn(40,40);
    break;
    case 3547934905: // Turn Left , Left Button.
    leftTurn(40,40);
    break;
    case 1382474152: //Stop , OK Button.
    rightservo.write(rightCenter);  
    leftservo.write(leftCenter);
    break;
    
   ////////////////////////////////////////////////////////////////////////////////////// 
    
    case 3505747018: // Arm Rotate Right, Right + volume button. 
    ArmRotateRight(20);
    break;
    
    case 50157735: // Arm Rotate Right, Left + volume button. 
    griperrotate.write(178); 
    break;
    
    ////////////////////////////////////////////////////////////////////////////////////
    
    case 653727150: // Arm Rotate Left, Right - volume button. 
    griperrotate.attach(6);
    ArmRotateLeft(20);
    break;
    
    case 50165895: // Arm Rotate Left, Left - volume button. 
    griperrotate.attach(6);
    griperrotate.write(2); 
    break;
    
    ///////////////////////////////////////////////////////////////////////////////////
    case 50137335: //  Mute Button.Opens the Griper and turns off the motor to save power, Mute button.
    ArmGriperOpen(180);
    break;
    
    case 418622043: // GoBack Button. Closes the Griper and Stays holding untill you press open. 
    ArmGriperStayOnClosed(0);
    break;
        
    case 1403937636: // Home/Guide Button. Returns the arm back to the start. 
    ArmToStart();
    break;
    
    
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////// Arm Controls    
   case 3769668639: //  Number 1 Button. Move arm servo up
     ArmGriper1moveBack(20);
    break;
    
   case 1452105873: // Number 2 Button. Move the arm to 90 degrees.
    griperarm1.attach(3);
    griperarm1.write(90);  
   break;
  
   case 2019021766: // Number 3 Button. Move arm servo down.
    ArmGriper1moveForward(20);
    break;

///////////////////////////////////////////////////////////////////////////////

   case 1970816586:  // Number 4 Button. Move arm Servo up
     ArmGriper2moveBack(20);
    break;
    
   case 2401173872: // Number 5 Button. Move the arm to 90 degrees.
    griperarm2.attach(4);
    griperarm2.write(90);  
   break;  
    
    
   case 3022567416: // Number 6 Button Move arm servo down
    ArmGriper2moveForward(20);
    break;


///////////////////////////////////////////////////////////////////////////////

   case 2726268758: // Grab and move the object up Hold object untill press open. Menu Button. 

    griper.attach(5); 
    griperarm1.attach(3); 
    griperarm2.attach(4); 
    griper.write(0);
    delay(100);
    griperarm2.write(30); 
    delay(1000);
    griperarm2.write(50); 
    griperarm1.write(50);
    delay(500);
    break;


 case 466199039: // Go down and Grab and move the object up Hold object untill press open. Play Button. 

    griper.attach(5); 
    griperarm1.attach(3); 
    griperarm2.attach(4); 
    griperarm2.write(145); 
    griperarm1.write(90);
    griper.write(180);
    delay(250);
    griper.write(0);
    delay(150);
    griperarm2.write(10); 
    delay(400);
    griperarm2.write(50); 
    griperarm1.write(50);
    delay(200);
    break;


    
}// End Of switch
irINput.resume();
  
}// End Of IF

}//End Of main

void forward(int servoSpeed ) {
      
    rightservo.write(rightCenter - (servoSpeed ));  
    leftservo.write(leftCenter +   (servoSpeed ));   
}


void backward(int servoSpeed ) {
  
    rightservo.write(rightCenter + (servoSpeed  ));  
    leftservo.write(leftCenter   -   (servoSpeed  ));   
    
}


void rightTurn(int servoSpeed, int turnSpeed) {
  
    rightservo.write(rightCenter + (servoSpeed  )    );  
    leftservo.write(leftCenter   + (servoSpeed  + turnSpeed)   );
}


void leftTurn(int servoSpeed, int turnSpeed) {
  
    rightservo.write(rightCenter - (servoSpeed   + turnSpeed ) );  
    leftservo.write(leftCenter   - (servoSpeed )   );
  
}


void ArmGriperOpen(int servoSpeed) {
    griper.attach(5);
    griper.write(servoSpeed);  
    delay(500);
    griper.detach();

}

void ArmGriperStayOnClosed(int servoSpeed) {
    griper.attach(5);
    griper.write(servoSpeed);  
    delay(500);
}

void ArmToStart () {
 
  griper.attach(5); 
  griperarm1.attach(3); 
  griperarm2.attach(4); 
  griperrotate.attach(6); //
  griper.write(gripercenter); 
  griperarm1.write(griperarm1center); 
  griperarm2.write(griperarm2center); 
  griperrotate.write(griperrotatecenter); 
  delay(800);
  griper.detach() ; 
  griperarm1.detach(); 
  griperarm2.detach(); 
  griperrotate.detach(); 

}




void ArmGriper1moveBack(int servoSpeed ) {
    griperarm1.attach(3);
    int pos = griperarm1.read();
    if(pos < 180 && pos + servoSpeed < 180){
    griperarm1.write(servoSpeed + pos);  

    }

}



void ArmGriper1moveForward(int servoSpeed ) {
    griperarm1.attach(3);
    int pos = griperarm1.read();
    if( pos > 0 && pos - servoSpeed > 0) {
    griperarm1.write(pos - servoSpeed); 

    } 

}



void ArmGriper2moveBack(int servoSpeed ) {
    griperarm2.attach(4);
    int pos = griperarm2.read();
    if(pos < 180 && pos + servoSpeed < 180){
    griperarm2.write(servoSpeed + pos); 

    } 
}

void ArmGriper2moveForward(int servoSpeed ) {
    griperarm2.attach(4);
    int pos = griperarm2.read();
     if( pos > 0 && pos - servoSpeed > 0) {  
    griperarm2.write(pos - servoSpeed); 

     } 
}



void ArmRotateRight( int servoSpeed1 ) {
    griperrotate.attach(6);
    int pos = griperrotate.read();
     if( pos > 0 && pos - servoSpeed1 > 0) {  
    griperrotate.write(pos - servoSpeed1); 

     } 
 
}

void ArmRotateLeft(int servoSpeed2 ) {
    griperrotate.attach(6);
    int pos = griperrotate.read();
    if(pos < 180 && pos + servoSpeed2 < 180){
    griperrotate.write(servoSpeed2 + pos); 

    } 

}

